Компонент **Button** предназначен для создания визуального эффекта нажатия кнопки.

Для использования этого компонента необходимо подключить модуль **button.js** и добавить в HTML-код пользовательский тэг **oda-button**.

Действия, которые необходимо выполнить при нажатии на кнопку, предусматриваются в обработчиках события данного компонента.

Например,

```javascript _run_line_edit_loadoda_[my-component.js]
ODA({
    is: 'my-component',
    imports: ['@oda/button'],
    template: `
        <oda-button label="Нажми на меня" icon="icons:android" blink="2000" @tap="onTap" ref="btn"></oda-button>
    `,
    onTap() {
        this.$refs.btn.label = 'Я кнопка';
    }
});
```

Данный компонент можно зафиксировать в нажатом состоянии, на его поверхности можно разместить любую иконку, задать ее цвет фона и контура, установить эффект мерцания, а также вывести любую необходимую надпись.
